/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.openrdf.elmo.impl;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import org.openrdf.concepts.skos.core.Concept;
import it.tidalwave.util.NotFoundException;

/**
 *
 * @author fritz
 */
public final class Utils
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public static <T> List<T> filtered (final @Nonnull Set<Concept> broaders, final @Nonnull Class<T> type)
      {
        assert broaders != null : "broaders is null";
        assert type != null : "type is null";

        final List<T> result = new ArrayList<T>();

        for (final Concept concept : broaders)
          {
            if (instanceOf(concept, type))
              {
                result.add((T) concept);
              }
          }

        return result;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public static <T> T single (final @Nonnull List<T> broaders)
      throws NotFoundException
      {
        switch (broaders.size())
          {
            case 0:
              throw new NotFoundException();

            case 1:
              return broaders.get(0);

            default:
              throw new RuntimeException("Multiple results found where zero or one are allowed");
          }
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static boolean instanceOf (final @Nonnull Object object, final @Nonnull Class<?> clazz)
      {
        if (clazz.isAssignableFrom(object.getClass()))
          {
            return true;
          }

        for (final Class<?> intf : object.getClass().getInterfaces())
          {
            if (clazz.isAssignableFrom(intf))
              {
                return true;
              }
          }

        return false;
      }
  }
